/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package it.inaf.oats.ia2.tap.utils.tapschema;

import it.inaf.oats.ia2.tap.utils.model.EditableValue;
import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author pietro
 */
public class Schema implements Serializable {

    public String schema_name;
    private String utype;
    private String description;
    //public List<Table> tablesList = new ArrayList<Table>();
    public Map<String, Table> tablesMap = new HashMap<String, Table>();

    //public List<Key> keysList = new ArrayList<Key>();
    public Map<String, Key> keysMap = new HashMap<String, Key>();
    //public List<KeyColumn> key_columnsList = new ArrayList<KeyColumn>();
    public Map<String, KeyColumn> key_columnsMap = new HashMap<String, KeyColumn>();

    private boolean checked;

    public Table getTable(String tableName) {
        return tablesMap.get(tableName);
    }

    public String getUtype() {
        return utype;
    }

    public void setUtype(String utype) {
        this.utype = utype;
    }

    public String getDescription() {
        return this.description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public boolean isChecked() {
        return checked;
    }

    public void setChecked(boolean checked) {
        this.checked = checked;
        for (Table table : tablesMap.values()) {
            table.setChecked(checked);
        }
    }
    
    public void verifyCheckedState() {
        boolean isChecked = false;
        for (Table table : tablesMap.values()) {
            if(table.isChecked()) {
                isChecked = true;
            }
        }
        this.checked = isChecked;
    }
}
